#include "c:\Progra~1\Matlab\EXTERN\INCLUDE\mex.h"

#include <stdio.h>

void mexFunction(int nlhs,mxArray *plhs[],
								 int nrhs, const mxArray *prhs[])
{
	//tdata_t img;
	int dim[2],flength;
	char *filename;
	FILE* layin;
	double *img;
	float *rawimg;
	int i,j,k; 
    unsigned char msg[4]; 
 

	if ((nrhs != 1)|| (nlhs != 1))
		mexErrMsgTxt("USAGE : imgdata=LAYread(<LAYimgFilename.)");
	if (mxIsChar(prhs[0])!=1) mexErrMsgTxt("Input must be a string.");
	if (mxGetM(prhs[0])!= 1) mexErrMsgTxt("Input must be a row vector.");
	flength = mxGetN(prhs[0])+1;
	filename=(char *)mxCalloc(flength,1);
	mxGetString(prhs[0],filename,flength);

	layin = fopen(filename,"rb");
    if (layin == NULL) mexErrMsgTxt("File does not exist.");
    fread(msg,1,4,layin);
    dim[0] = ((msg[1] << 8) | msg[0])*3; 
    dim[1] = (msg[3] << 8) | msg[2];// get, set filesize; 
    if(dim[0]==0 || dim[1]==0)  
      mexErrMsgTxt("Attempted to read empty file!"); 
	rawimg = (float *)malloc(dim[0]*dim[1]*4);
	//fread((unsigned char *)rawimg,1,dim[0]*dim[1]*4,layin);
	fread((unsigned char *)rawimg,4,dim[0]*dim[1],layin);
	fclose(layin);

	//plhs[0] = mxCreateNumericArray(2,dim,mxINT16_CLASS,mxREAL);
	plhs[0] = mxCreateDoubleMatrix(dim[0], dim[1], mxREAL);
	if (plhs[0] == NULL) mexErrMsgTxt("Can't create the return array.");
	img = (double *)mxGetPr(plhs[0]);
    for(j=k=0; j<dim[1]; j++)     // for every scanline, 
      for(i=0; i<dim[0]; i++,k++)   // and every pixel on the scanline, 
		  img[k] = rawimg[k];
	  /*
        if (rawimg[k] > 1.0) img[k] = (short)(256*128 -1);
	    else if (rawimg[k] <= 0) img[k] = (short) 0;
	    else img[k] = (short)(rawimg[k]*(256.*128. -1.));	
		*/
	free(img);
	free(rawimg);
}


